Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QTextCodec

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.core.QTextCodec

All Implemented Interfaces:
  QtJambiInterface

    public abstract class QTextCodec

extends QtJambiObject

The `QTextCodec` class provides conversions between text encodings. Qt uses Unicode to store, draw and manipulate strings. In many situations you may wish to deal with data that uses a different encoding. For example, most Japanese documents are still stored in Shift-JIS or ISO 2022-JP, while Russian users often have their documents in KOI8-R or Windows-1251.

Qt provides a set of `QTextCodec` classes to help with converting non-Unicode formats to and from Unicode. You can also create your own codec classes.

The supported encodings are:

- Apple Roman
- Big5
- Big5-HKSCS
- EUC-JP
- EUC-KR
- GB18030-0
- IBM 850
- IBM 866
- IBM 874
- ISO 2022-JP
- ISO 8859-1 to 10
- ISO 8859-13 to 16
- Iscii-Bng, Dev, Gjr, Knd, Mlm, Ori, Pnj, Tlg, and Tml
- JIS X 0201
- JIS X 0208
- KOI8-R
- KOI8-U
- MuleLao-1
- ROMAN8
- Shift-JIS
- TIS-620
- TSCII
- UTF-8
- UTF-16
- UTF-16BE
- UTF-16LE
- UTF-32
- UTF-32BE
- UTF-32LE
- Windows-1250 to 1258
- WINSAMI2

QTextCodecs can be used as follows to convert some locally encoded string to Unicode. Suppose you have some string encoded in Russian KOI8-R encoding, and want to convert it to Unicode. The simple way to do it is like this:

            QByteArray encodedString = new QByteArray("...");
            QTextCodec codec = QTextCodec.codecForName("KOI8-R");
            String string = codec.toUnicode(encodedString);

After this, `string` holds the text converted to Unicode. Converting a string from Unicode to the local encoding is just as easy:

            String string = new String("...");
            QTextCodec codec = QTextCodec.codecForName("KOI8-R");
            QByteArray encodedString = codec.fromUnicode(string);

To read or write files in various encodings, use `QTextStream` and its `setCodec()` function. See the Codecs example for an application of `QTextCodec` to file I/O.

Some care must be taken when trying to convert the data in chunks, for example, when receiving it over a network. In such cases it is possible that a multi-byte character will be split over two chunks. At best this might result in the loss of a character and at worst cause the entire conversion to fail.

The approach to use in these situations is to create a `QTextDecoder` object for the codec and use this `QTextDecoder` for the whole decoding process, as shown below:

            QTextCodec codec = QTextCodec.codecForName("Shift-JIS");
            QTextDecoder decoder = codec.makeDecoder();

            String string = new String();
            while (new_data_available()) {
                QByteArray chunk = get_new_data();
                string += decoder.toUnicode(chunk);
            }

The `QTextDecoder` object maintains state between chunks and therefore works correctly even if a multi-byte character is split between chunks.

## Creating Your Own Codec Class

Support for new text encodings can be added to Qt by creating `QTextCodec` subclasses.

The pure virtual functions describe the encoder to the system and the coder is used as required in the different text file formats supported by `QTextStream`, and under X11, for the locale-specific character input and output.

To add support for another encoding to Qt, make a subclass of `QTextCodec` and implement the functions listed in the table below.

Function | Description
--- | ---
`name()` | Returns the official name for the encoding. If the ncoding is listed in the IANA character-sets encoding file, the name should be the preferred MIME name for the encoding.
`aliases()` | Returns a list of alternative names for the encoding. `QTextCodec` provides a default implementation that returns an empty list. For example, "ISO-8859-1" has "latin1", "CP819", "IBM819", and "iso-ir-100" as aliases.
`mibEnum()` | Return the MIB enum for the encoding if it is listed in the IANA character-sets encoding file.
`convertToUnicode()` | Converts an 8-bit character string to Unicode.
`convertFromUnicode()` | Converts a Unicode string to an 8-bit character string.

You may find it more convenient to make your codec class available as a plugin; see How to Create Qt Plugins for details.

See also:
  `QTextStream`, `QTextDecoder`, `QTextEncoder`, and Codecs Example.

Nested Class Summary
`static class` | `QTextCodec.ConversionFlag`
`static class` | `QTextCodec.ConversionFlags` This is a flags class for com.trolltech.qt.core.QTextCodec.ConversionFlag

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`protected` | `QTextCodec()` Constructs a `QTextCodec`, and gives it the highest precedence.

Method Summary
`java.util.List` | `aliases()` Subclasses can return a number of aliases for the codec in question.
`static java.util.List` | `availableCodecs()` Returns the list of all available codecs, by name.
`static java.util.List` | `availableMibs()` Returns the list of MIBs for all available codecs.
`boolean` | `canEncode(char arg__1)` Returns true if the Unicode character `ch` can be fully encoded with this codec; otherwise returns false.
`boolean` | `canEncode(java.lang.String arg__1)` `s` contains the string being tested for encode-ability.
`static QTextCodec` | `codecForCStrings()` Returns the codec used by QString to convert to and from `const char *` and QByteArrays.
`static QTextCodec` | `codecForHtml(QByteArray ba)` If the codec cannot be detected, this overload returns a Latin-1 `QTextCodec`.
`static QTextCodec` | `codecForHtml(QByteArray ba, QTextCodec defaultCodec)` Tries to detect the encoding of the provided snippet of html in the given byte array, `ba`, and returns a `QTextCodec` instance that is capable of decoding the html to unicode.
`static QTextCodec` | `codecForLocale()` Returns a pointer to the codec most suitable for this locale.
`static QTextCodec` | `codecForMib(int mib)` Returns the `QTextCodec` which matches the `MIBenum` `mib`.
`static QTextCodec` | `codecForName(QByteArray name)` Searches all installed `QTextCodec` objects and returns the one which best matches `name`; the match is case-insensitive.
`static QTextCodec` | `codecForName(java.lang.String name)` Searches all installed QTextCodec objects and returns the one which best matches `name`; the match is case-insensitive.
`protected abstract QByteArray` | `convertFromUnicode(char[] in, int length, QTextCodec_ConverterState state)` `QTextCodec` subclasses must reimplement this function.
`protected abstract java.lang.String` | `convertToUnicode(byte[] in, int length, QTextCodec_ConverterState state)` `QTextCodec` subclasses must reimplement this function.
`QByteArray` | `fromUnicode(java.lang.String uc)` Converts `str` from Unicode to the encoding of this codec, and returns the result in a `QByteArray`.
`QTextDecoder` | `makeDecoder()` Creates a `QTextDecoder` which stores enough state to decode chunks of `char *` data to create chunks of Unicode data.
`QTextEncoder` | `makeEncoder()` Creates a `QTextEncoder` which stores enough state to encode chunks of Unicode data as `char *` data.
`abstract int` | `mibEnum()` Subclasses of `QTextCodec` must reimplement this function.
`abstract QByteArray` | `name()` `QTextCodec` subclasses must reimplement this function.
`static void` | `setCodecForCStrings(QTextCodec c)` Sets the codec used by QString to convert to and from `const char *` and QByteArrays.
`static void` | `setCodecForLocale(QTextCodec c)` Set the codec to `c`; this will be returned by `codecForLocale()`.
`java.lang.String` | `toUnicode(QByteArray arg__1)` Converts `a` from the encoding of this codec to Unicode, and returns the result in a QString.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QTextCodec

    protected QTextCodec()

  Constructs a `QTextCodec`, and gives it the highest precedence. The `QTextCodec` should always be constructed on the heap (i.e. with `new`). Qt takes ownership and will delete it when the application terminates.

Method Detail

### canEncode

    public final boolean canEncode(char arg__1)

  Returns true if the Unicode character `ch` can be fully encoded with this codec; otherwise returns false.

### canEncode

    public final boolean canEncode(java.lang.String arg__1)

  `s` contains the string being tested for encode-ability.

### fromUnicode

    public final QByteArray fromUnicode(java.lang.String uc)

  Converts `str` from Unicode to the encoding of this codec, and returns the result in a `QByteArray`.

### makeDecoder

    public final QTextDecoder makeDecoder()

  Creates a `QTextDecoder` which stores enough state to decode chunks of `char *` data to create chunks of Unicode data.

  The caller is responsible for deleting the returned object.

### makeEncoder

    public final QTextEncoder makeEncoder()

  Creates a `QTextEncoder` which stores enough state to encode chunks of Unicode data as `char *` data.

  The caller is responsible for deleting the returned object.

### toUnicode

    public final java.lang.String toUnicode(QByteArray arg__1)

  Converts `a` from the encoding of this codec to Unicode, and returns the result in a QString.

### aliases

    public java.util.List aliases()

  Subclasses can return a number of aliases for the codec in question.

  Standard aliases for codecs can be found in the IANA character-sets encoding file.

### convertFromUnicode

    protected abstract QByteArray convertFromUnicode(char[] in,
                                                     int length,
                                                     QTextCodec_ConverterState state)

  `QTextCodec` subclasses must reimplement this function.

  Converts the first `number` of characters from the `input` array from Unicode to the encoding of the subclass, and returns the result in a `QByteArray`.

  `state` can be 0 in which case the conversion is stateless and default conversion rules should be used. If state is not 0, the codec should save the state after the conversion in `state`, and adjust the remainingChars and invalidChars members of the struct.

### convertToUnicode

    protected abstract java.lang.String convertToUnicode(byte[] in,
                                                         int length,
                                                         QTextCodec_ConverterState state)

  `QTextCodec` subclasses must reimplement this function.

  Converts the first `len` characters of `chars` from the encoding of the subclass to Unicode, and returns the result in a QString.

  `state` can be 0, in which case the conversion is stateless and default conversion rules should be used. If state is not 0, the codec should save the state after the conversion in `state`, and adjust the remainingChars and invalidChars members of the struct.

### mibEnum

    public abstract int mibEnum()

  Subclasses of `QTextCodec` must reimplement this function. It returns the MIBenum (see the IANA character-sets encoding file for more information). It is important that each `QTextCodec` subclass returns the correct unique value for this function.

### name

    public abstract QByteArray name()

  `QTextCodec` subclasses must reimplement this function. It returns the name of the encoding supported by the subclass.

  If the codec is registered as a character set in the IANA character-sets encoding file this method should return the preferred mime name for the codec if defined, otherwise its name.

### availableCodecs

    public static java.util.List availableCodecs()

  Returns the list of all available codecs, by name. Call `QTextCodec::codecForName()` to obtain the `QTextCodec` for the name.

  The list may contain many mentions of the same codec if the codec has aliases.

See also:
  `availableMibs()`, `name()`, and `aliases()`.

### availableMibs

    public static java.util.List availableMibs()

  Returns the list of MIBs for all available codecs. Call `QTextCodec::codecForMib()` to obtain the `QTextCodec` for the MIB.

See also:
  `availableCodecs()`, and `mibEnum()`.

### codecForCStrings

    public static QTextCodec codecForCStrings()

  Returns the codec used by QString to convert to and from `const char *` and QByteArrays. If this function returns 0 (the default), QString assumes Latin-1.

See also:
  `setCodecForCStrings()`.

### codecForHtml

    public static QTextCodec codecForHtml(QByteArray ba)

  If the codec cannot be detected, this overload returns a Latin-1 `QTextCodec`.

### codecForHtml

    public static QTextCodec codecForHtml(QByteArray ba,
                                          QTextCodec defaultCodec)

  Tries to detect the encoding of the provided snippet of html in the given byte array, `ba`, and returns a `QTextCodec` instance that is capable of decoding the html to unicode. If the codec cannot be detected from the content provided, `defaultCodec` is returned.

### codecForLocale

    public static QTextCodec codecForLocale()

  Returns a pointer to the codec most suitable for this locale.

  On Windows, the codec will be based on a system locale. On Unix systems, starting with Qt 4.2, the codec will be using the iconv library. Note that in both cases the codec's name will be "System".

See also:
  `setCodecForLocale()`.

### codecForMib

    public static QTextCodec codecForMib(int mib)

  Returns the `QTextCodec` which matches the `MIBenum` `mib`.

### codecForName

    public static QTextCodec codecForName(QByteArray name)

  Searches all installed `QTextCodec` objects and returns the one which best matches `name`; the match is case-insensitive. Returns 0 if no codec matching the name `name` could be found.

### setCodecForCStrings

    public static void setCodecForCStrings(QTextCodec c)

  Sets the codec used by QString to convert to and from `const char *` and QByteArrays. If the `codec` is 0 (the default), QString assumes Latin-1.

  Warning: Some codecs do not preserve the characters in the ASCII range (0x00 to 0x7F). For example, the Japanese Shift-JIS encoding maps the backslash character (0x5A) to the Yen character. To avoid undesirable side-effects, we recommend avoiding such codecs with setCodecsForCString().

See also:
  `codecForCStrings()`, and setCodecForTr().

### setCodecForLocale

    public static void setCodecForLocale(QTextCodec c)

  Set the codec to `c`; this will be returned by `codecForLocale()`. If `is` a null pointer, the codec is reset to the default.

  This might be needed for some applications that want to use their own mechanism for setting the locale.

  Setting this codec is not supported on DOS based Windows.

See also:
  `codecForLocale()`.

### codecForName

    public static QTextCodec codecForName(java.lang.String name)

  Searches all installed QTextCodec objects and returns the one which best matches `name`; the match is case-insensitive. Returns 0 if no codec matching the name \a name could be found.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD